using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Web.Mvc;
using Syncfusion.Presentation;
using Syncfusion.XlsIO;
using System.Drawing;
using CultureAudit.Models;

namespace CultureAudit.Areas.Admin.Controllers
{
    public class PowerPointController : Controller
    {
        CultureAuditEntities db = new CultureAuditEntities();

        // GET: Admin/PowerPoint
        public ActionResult Index()
        {
            return View();
        }


         
        public PresentationResult ReportPresentation(int SurveyNumber)
        {
            SurveyDefinition survey = new SurveyDefinition();
            string companyName = survey.GetCompany(SurveyNumber);
            string CompanyNoSpaceName = companyName.Replace(" ", "_");

            string SurveyName = survey.GetSurveyName(SurveyNumber);
            string NoSpaceName = SurveyName.Replace(" ", "_");
            // the following variables will be used to display the info in the table
            int sd;
            int d;
            int nand;
            int a;
            int sa;
            int sdpts;
            int dpts;
            int nandpts;
            int apts;
            int sapts;
            int total;
            int totalpts;
            string percentsd;
            string percentd;
            string percentnand;
            string percenta;
            string percentsa;
            double avg;
            bool hasGroup6 = false;

            // Cannot get data directly from database for charts.   It can only come from spreadsheets so we will create a spreadsheet which we will delete after the presentation has been created 
            using (ExcelEngine excelEngine = new ExcelEngine())
            {
  
                // Set the default application version as Excel 2016.
                excelEngine.Excel.DefaultVersion = ExcelVersion.Excel2016;

                // Create a workbook with all needed worksheets.
                IWorkbook workbook = excelEngine.Excel.Workbooks.Create(new string[] { "Q1", "Q2","Q3","Q4", "Q5", "Q6", "Q7", "Q8", "Q9","Q10", "Q11", "Q12","Q13","Q14", "Q15","Q16", "Q17", "Q18" });

                // Access first worksheet from the workbook instance.
                IWorksheet sheet0 = workbook.Worksheets[0];

                // Create instance of class  -- will reuse on each worksheet
                AverageAnswerByGroup mod = new AverageAnswerByGroup();

                // Assign variables needed for this worksheet
                mod.GroupNumber = 1;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group1 = mod.AverageGroupScores();
                sheet0.ImportData(group1, 1, 1, true);

                // Access 2nd worksheet from the workbook instance.
                IWorksheet sheet1 = workbook.Worksheets[1];
                PhraseInstance phrase = new PhraseInstance();
                phrase.GroupNumber = 2;
                phrase.SurveyNumber = SurveyNumber;
                IList<DisplayInstancesOfPhrase_Result> DoesWell = phrase.PhrasesUsed();
                sheet1.ImportData(DoesWell, 1, 1, true);

                // Access 3rd worksheet from the workbook instance.
                IWorksheet sheet2 = workbook.Worksheets[2];
                phrase.GroupNumber = 3;
                phrase.SurveyNumber = SurveyNumber;
                IList<DisplayInstancesOfPhrase_Result> DoBetter = phrase.PhrasesUsed();
                sheet2.ImportData(DoBetter, 1, 1, true);

                // Access 4th worksheet from the workbook instance.
                IWorksheet sheet3 = workbook.Worksheets[3];
                mod.GroupNumber = 4;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group4 = mod.AverageGroupScores();
                sheet3.ImportData(group4, 1, 1, true);


                // Access 5th worksheet from the workbook instance.
                IWorksheet sheet4 = workbook.Worksheets[4];
                mod.GroupNumber = 5;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group5 = mod.AverageGroupScores();
                sheet4.ImportData(group5, 1, 1, true);

                // Access 6th worksheet from the workbook instance.
                IWorksheet sheet5 = workbook.Worksheets[5];
                mod.GroupNumber = 6;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group6 = mod.AverageGroupScores();
                if (group6.Count > 0)
                {
                    sheet5.ImportData(group6, 1, 1, true);
                }

                // Access 7th worksheet from the workbook instance.
                IWorksheet sheet6 = workbook.Worksheets[6];
                mod.GroupNumber = 7;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group7 = mod.AverageGroupScores();
                sheet6.ImportData(group7, 1, 1, true);

                // Access 8th worksheet from the workbook instance.
                IWorksheet sheet7 = workbook.Worksheets[7];
                mod.GroupNumber = 8;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group8 = mod.AverageGroupScores();
                sheet7.ImportData(group8, 1, 1, true);

                // Access 9th worksheet from the workbook instance.
                IWorksheet sheet8 = workbook.Worksheets[8];
                mod.GroupNumber = 9;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group9 = mod.AverageGroupScores();
                sheet8.ImportData(group9, 1, 1, true);

                // Access 9th worksheet from the workbook instance.
                RadioButtonAnswers rba = new RadioButtonAnswers();
                rba.SurveyNumber = SurveyNumber;
                rba.GroupNumber = 10;
                IWorksheet sheet9 = workbook.Worksheets[9];
                IList<GetRadioAnswerOccurances_Result> IdeasRadio = rba.RadioAnswers();
                sheet9.ImportData(IdeasRadio, 1, 1, true);

                // Access 10th worksheet from the workbook instance.
                IWorksheet sheet10 = workbook.Worksheets[10];
                mod.GroupNumber = 11;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group11 = mod.AverageGroupScores();
                sheet10.ImportData(group11, 1, 1, true);

                // Access 11th worksheet from the workbook instance.
                IWorksheet sheet11 = workbook.Worksheets[11];
                mod.GroupNumber = 12;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group12 = mod.AverageGroupScores();
                sheet11.ImportData(group12, 1, 1, true);

                // Access 12th worksheet from the workbook instance.
                IWorksheet sheet12 = workbook.Worksheets[12];
                CheckBoxAnswers cba = new CheckBoxAnswers();
                cba.GroupNumber = 13;
                cba.SurveyNumber = SurveyNumber;
                IList<DisplayCheckBoxInstances_Result> HowCommunicate = cba.CheckAllAnswers();
                sheet12.ImportData(HowCommunicate, 1, 1, true);

                // Access 13th worksheet from the workbook instance.
                IWorksheet sheet13 = workbook.Worksheets[13];
                cba.GroupNumber = 14;
                cba.SurveyNumber = SurveyNumber;
                IList<DisplayCheckBoxInstances_Result> PreferCommunicate = cba.CheckAllAnswers();
                sheet13.ImportData(PreferCommunicate, 1, 1, true);

                // Access 14th worksheet from the workbook instance.
                IWorksheet sheet14 = workbook.Worksheets[14];
                mod.GroupNumber = 15;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group15 = mod.AverageGroupScores();
                sheet14.ImportData(group15, 1, 1, true);

                // Access 15th worksheet from the workbook instance.
                IWorksheet sheet15 = workbook.Worksheets[15];
                phrase.GroupNumber = 16;
                phrase.SurveyNumber = SurveyNumber;
                IList<DisplayInstancesOfPhrase_Result> CoreValues = phrase.PhrasesUsed();
                sheet15.ImportData(CoreValues, 3, 1, true);

                // Access 16th worksheet from the workbook instance.
                IWorksheet sheet16 = workbook.Worksheets[16];
                mod.GroupNumber = 17;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group17 = mod.AverageGroupScores();
                sheet16.ImportData(group17, 1, 1, true);

                // Access 17th worksheet from the workbook instance.
                IWorksheet sheet17 = workbook.Worksheets[17];
                mod.GroupNumber = 18;
                mod.SurveyNumber = SurveyNumber;

                IList<AverageGroupAnswer_Result> group18 = mod.AverageGroupScores();
                sheet17.ImportData(group8, 1, 1, true);
               
                //Save the spreadsheet on the server
                workbook.SaveAs(Server.MapPath("/App_Data/"+ NoSpaceName +".xlsx"));
            }
            //This is the excel spreadsheet we just created
            string file = Server.MapPath("/App_Data/" + NoSpaceName + ".xlsx");
            ExcelEngine excelEngine2 = new ExcelEngine();
            //Open the excel application.
            IApplication application = excelEngine2.Excel;

            IWorkbook destworkbook = application.Workbooks.Open(file);


            int numCompleted = survey.CountParticipants(SurveyNumber, "Y");
            int Section1 = survey.CountParticipants(SurveyNumber, "1");
            int Participants = numCompleted + Section1;

            //Open a powerpoint presentation
            IPresentation presentation = Presentation.Create();

            //Add cover slide
            ISlide Slide0 = presentation.Slides.Add(SlideLayoutType.Blank);
            Syncfusion.Presentation.IShape textShape = Slide0.AddTextBox(100, 75, 756, 800);
            IParagraph paragraph = textShape.TextBody.AddParagraph();

            //Add some text to it.
            ITextPart textPart = paragraph.AddTextPart(companyName);

            //Set the horizontal alignment of paragraph
            paragraph.HorizontalAlignment = HorizontalAlignmentType.Center;

            //Apply font formatting to the above text
            textPart.Font.FontSize = 80;
            textPart.Font.Bold = true;

            IParagraph titleParagraph = textShape.TextBody.AddParagraph();
            ITextPart Title = titleParagraph.AddTextPart("\r\n"+SurveyName);
            titleParagraph.HorizontalAlignment = HorizontalAlignmentType.Center;
            Title.Font.FontSize = 50;
            Title.Font.Bold = true;
         

            //create new slide
            ISlide Slide1 = presentation.Slides.Add(SlideLayoutType.Blank);
            Syncfusion.Presentation.IShape textShape1 = Slide1.AddTextBox(50, 25, 856, 30);
            IParagraph paragraph1 = textShape1.TextBody.AddParagraph();
            //Get the text to put in header
            string Group1Text = survey.GetGroupText(1);

            //Add above text to this slide above the table
            ITextPart textPart1 = paragraph1.AddTextPart(Group1Text);
            paragraph1.HorizontalAlignment = HorizontalAlignmentType.Center;
            textPart1.Font.Bold = true;
            //get the data for the table
            var Group1Data = db.SurveyScoresByGroup(1, SurveyNumber).ToList();
            int numRows = Group1Data.Count();
            int z = 1;

            //Add a table of info
            ITable table1 = Slide1.Shapes.AddTable((numRows+1), 8, 40, 70, 856, 500);
            IRow row = table1.Rows[0];
            row.Height = 30;
            ICell cell = table1[0, 0];
            cell.TextBody.AddParagraph("");
            cell.ColumnWidth = 300;
            cell = table1[0, 1];
            cell.TextBody.AddParagraph("Strongly\r\nDisagree");
            cell.ColumnWidth = 75;
            ITextPart text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 2];
            cell.TextBody.AddParagraph("Disagree");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 3];
            cell.TextBody.AddParagraph("Neither Agree\r\nNor Disagree");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 4];
            cell.TextBody.AddParagraph("Agree");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 5];
            cell.TextBody.AddParagraph("Strongly\r\nAgree");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 6];
            cell.TextBody.AddParagraph("Total\r\nParticipants");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            cell = table1[0, 7];
            cell.TextBody.AddParagraph("Weighted\r\nAverage");
            cell.ColumnWidth = 75;
            text = cell.TextBody.Paragraphs[0].TextParts[0];
            text.Font.FontSize = 10;
            foreach (var x in Group1Data)
            {
                int y = 0;
                //determine values for each variable
                sd = Convert.ToInt16(x.StronglyDisagree);
                sdpts = sd * 1;
                if (sd > 0)
                {
                    percentsd = string.Format("{0:N2}", (Convert.ToDouble(sd) / Convert.ToDouble(Participants)) * 100);
                }
                else
                {
                    percentsd = "0%";
                }

                d = Convert.ToInt16(x.Disagree);
                dpts = d * 2;
                if (d > 0)
                {
                    percentd = string.Format("{0:N2}", (Convert.ToDouble(d) / Convert.ToDouble(Participants)) * 100);
                }
                else
                {
                    percentd = "0%";
                }

                nand = Convert.ToInt16(x.NAND);
                nandpts = nand * 3;

                if (nand > 0)
                {
                    percentnand = string.Format("{0:N2}", (Convert.ToDouble(nand) / Convert.ToDouble(Participants)) * 100);
                }
                else
                {
                    percentnand = "0%";
                }

                a = Convert.ToInt16(x.Agree);
                apts = a * 4;

                if (a > 0)
                {
                    percenta = string.Format("{0:N2}%", (Convert.ToDouble(a) / Convert.ToDouble(Participants)) * 100);
                }
                else
                {
                    percenta = "0%";
                }

                sa = Convert.ToInt16(x.StronglyAgree);
                sapts = sa * 5;
                if (sa > 0)
                {
                    percentsa = string.Format("{0:N2}%", (Convert.ToDouble(sa) / Convert.ToDouble(Participants)) * 100);
                }
                else
                {
                    percentsa = "0%";
                }
                total = sd + d + nand + a + sa;
                totalpts = sdpts + dpts + nandpts + apts + sapts;
                avg = Convert.ToDouble(totalpts) / Convert.ToDouble(total);


                //display the information in this row
                row = table1.Rows[z];
                row.Height = 40;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(x.QuestionText.Replace("#Company#", companyName));
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;  // column increment
                cell = table1[z, y];
                cell.TextBody.AddParagraph(percentsd.ToString()+"\r\n"+sd.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(percentd.ToString() + "\r\n" + d.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(percentnand.ToString() + "\r\n" + nand.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(percenta.ToString() + "\r\n" + a.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(percentsa.ToString() + "\r\n" + sa.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(total.ToString());
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                y++;
                cell = table1[z, y];
                cell.TextBody.AddParagraph(avg.ToString("N2"));
                text = cell.TextBody.Paragraphs[0].TextParts[0];
                text.Font.FontSize = 10;
                z++;  //row increment
            }

            // Add a chart
            Stream stream = new FileStream(file, FileMode.Open);
            stream.Position = 0;

            //Gets the 1st worksheet
            IWorksheet worksheet0 = destworkbook.Worksheets[0];
			
			
			///this however, will not work
			//Gets the 4th worksheet
            //IWorksheet worksheet0 = destworkbook.Worksheets[3];
			
			//neither will this
			//IWorksheet worksheet0 = destworkbook.Worksheets["Q4"];
			
            worksheet0.UsedRangeIncludesFormatting = false;

            //Get The range of values
            var data1 = worksheet0.UsedRange;

            //create new slide showing chart
            ISlide chart1slide = presentation.Slides.Add(SlideLayoutType.Blank);
            IPresentationChart chart1 = chart1slide.Charts.AddChart(stream, 1, data1.Address, new Rectangle(30, 15, 850, 227)); 
            chart1.ChartType = Syncfusion.OfficeChart.OfficeChartType.Bar_Clustered;
            chart1.HasLegend = false;
            chart1.ChartTitle = "Average Answer";


            stream.Dispose();

			/*
				Create other slides
				/....
		   
			*/

            //close the workbook
            destworkbook.Close();

            excelEngine2.Dispose();

            //Now delete the Excel file used to create the charts
            //if ((System.IO.File.Exists(file)))
            //{
            //    System.IO.File.Delete(file);
            //}

            return new PresentationResult(presentation, NoSpaceName+".pptx", HttpContext.ApplicationInstance.Response);
        }
    }
}
 